#include <ctype.h>  /* NOLINT */
#include <stdio.h>  /* NOLINT */
#include <stdlib.h> /* NOLINT */
#include <string.h> /* NOLINT */
#include <time.h>   /* NOLINT */

#if defined(_MSC_VER)
#pragma warning(disable : 4996) /* deprecation */
#endif



/* Forward declare test functions. */
int sha256_nist_test_case_1(int, char*[]);
int sha256_nist_test_case_2(int, char*[]);
int sha256_nist_test_case_3(int, char*[]);
int sha256_nist_test_case_4(int, char*[]);
int sha256_nist_test_case_5(int, char*[]);
int sha256_nist_test_case_5_truncated(int, char*[]);
int sha256_nist_test_case_6(int, char*[]);
int sha256_test_invalid_buffer(int, char*[]);
int sha256_test_oneshot(int, char*[]);
int sha256_test_invalid_state(int, char*[]);
int sha256_test_extra_buffer_space(int, char*[]);
int sha1_nist_test_case_1(int, char*[]);
int sha1_nist_test_case_2(int, char*[]);
int sha1_nist_test_case_3(int, char*[]);
int sha1_nist_test_case_4(int, char*[]);
int sha1_nist_test_case_5(int, char*[]);
int sha1_nist_test_case_5_truncated(int, char*[]);
int sha1_nist_test_case_6(int, char*[]);
int sha1_test_invalid_buffer(int, char*[]);
int sha1_test_oneshot(int, char*[]);
int sha1_test_invalid_state(int, char*[]);
int sha1_test_extra_buffer_space(int, char*[]);
int md5_rfc1321_test_case_1(int, char*[]);
int md5_rfc1321_test_case_2(int, char*[]);
int md5_rfc1321_test_case_3(int, char*[]);
int md5_rfc1321_test_case_4(int, char*[]);
int md5_rfc1321_test_case_5(int, char*[]);
int md5_rfc1321_test_case_6(int, char*[]);
int md5_rfc1321_test_case_7(int, char*[]);
int md5_rfc1321_test_case_7_truncated(int, char*[]);
int md5_verify_known_collision(int, char*[]);
int md5_invalid_buffer_size(int, char*[]);
int md5_test_invalid_state(int, char*[]);
int md5_test_extra_buffer_space(int, char*[]);
int sha256_hmac_rfc4231_test_case_1(int, char*[]);
int sha256_hmac_rfc4231_test_case_2(int, char*[]);
int sha256_hmac_rfc4231_test_case_3(int, char*[]);
int sha256_hmac_rfc4231_test_case_4(int, char*[]);
int sha256_hmac_rfc4231_test_case_5(int, char*[]);
int sha256_hmac_rfc4231_test_case_6(int, char*[]);
int sha256_hmac_rfc4231_test_case_7(int, char*[]);
int sha256_hmac_test_oneshot(int, char*[]);
int sha256_hmac_test_invalid_buffer(int, char*[]);
int sha256_hmac_test_invalid_state(int, char*[]);
int sha256_hmac_test_extra_buffer_space(int, char*[]);
int ecdsa_p256_test_pub_key_derivation(int, char*[]);
int ecdsa_p384_test_pub_key_derivation(int, char*[]);
int ecdsa_p256_test_known_signing_value(int, char*[]);
int ecdsa_p384_test_known_signing_value(int, char*[]);
int ecdsa_test_invalid_signature(int, char*[]);
int ecdsa_p256_test_key_gen(int, char*[]);
int ecdsa_p384_test_key_gen(int, char*[]);
int ecdsa_p256_test_key_gen_export(int, char*[]);
int ecdsa_p384_test_key_gen_export(int, char*[]);
int ecdsa_p256_test_import_asn1_key_pair(int, char*[]);
int ecdsa_p384_test_import_asn1_key_pair(int, char*[]);
int ecdsa_test_import_asn1_key_pair_public_only(int, char*[]);
int ecdsa_test_import_asn1_key_pair_invalid_fails(int, char*[]);
int ecdsa_test_signature_format(int, char*[]);
int ecdsa_p256_test_small_coordinate_verification(int, char*[]);
int rsa_encryption_roundtrip_pkcs1_from_user(int, char*[]);
int rsa_encryption_roundtrip_oaep_sha256_from_user(int, char*[]);
int rsa_encryption_roundtrip_oaep_sha512_from_user(int, char*[]);
int rsa_signing_roundtrip_pkcs1_sha256_from_user(int, char*[]);
int rsa_signing_roundtrip_pss_sha256_from_user(int, char*[]);
int rsa_getters(int, char*[]);
int rsa_private_pkcs1_der_parsing(int, char*[]);
int rsa_public_pkcs1_der_parsing(int, char*[]);
int rsa_verify_signing_pkcs1_sha256(int, char*[]);
int rsa_verify_signing_pss_sha256(int, char*[]);
int rsa_decrypt_pkcs1(int, char*[]);
int rsa_decrypt_oaep256(int, char*[]);
int rsa_decrypt_oaep512(int, char*[]);
int rsa_signing_mismatch_pkcs1_sha256(int, char*[]);
int aes_cbc_NIST_CBCGFSbox256_case_1(int, char*[]);
int aes_cbc_NIST_CBCVarKey256_case_254(int, char*[]);
int aes_cbc_NIST_CBCVarTxt256_case_110(int, char*[]);
int aes_cbc_NIST_CBCMMT256_case_4(int, char*[]);
int aes_cbc_NIST_CBCMMT256_case_9(int, char*[]);
int aes_cbc_test_with_generated_key_iv(int, char*[]);
int aes_cbc_validate_materials_fails(int, char*[]);
int aes_ctr_RFC3686_Case_7(int, char*[]);
int aes_ctr_RFC3686_Case_8(int, char*[]);
int aes_ctr_RFC3686_Case_9(int, char*[]);
int aes_ctr_test_with_generated_key_iv(int, char*[]);
int aes_ctr_validate_materials_fails(int, char*[]);
int gcm_NIST_gcmEncryptExtIV256_PTLen_128_Test_0(int, char*[]);
int gcm_NIST_gcmEncryptExtIV256_PTLen_104_Test_3(int, char*[]);
int gcm_NIST_gcmEncryptExtIV256_PTLen_256_Test_6(int, char*[]);
int gcm_NIST_gcmEncryptExtIV256_PTLen_408_Test_8(int, char*[]);
int gcm_256_KAT_1(int, char*[]);
int gcm_256_KAT_2(int, char*[]);
int gcm_256_KAT_3(int, char*[]);
int gcm_test_with_generated_key_iv(int, char*[]);
int aes_gcm_validate_materials_fails(int, char*[]);
int aes_keywrap_RFC3394_256BitKey256CekTestVector(int, char*[]);
int aes_keywrap_Rfc3394_256BitKey_TestIntegrityCheckFailed(int, char*[]);
int aes_keywrap_RFC3394_256BitKeyTestBadPayload(int, char*[]);
int aes_keywrap_RFC3394_256BitKey128BitCekTestVector(int, char*[]);
int aes_keywrap_RFC3394_256BitKey128BitCekIntegrityCheckFailedTestVector(int, char*[]);
int aes_keywrap_RFC3394_256BitKey128BitCekPayloadCheckFailedTestVector(int, char*[]);
int aes_keywrap_validate_materials_fails(int, char*[]);
int aes_test_input_too_large(int, char*[]);
int der_encode_integer(int, char*[]);
int der_encode_integer_zero(int, char*[]);
int der_encode_boolean(int, char*[]);
int der_encode_null(int, char*[]);
int der_encode_bit_string(int, char*[]);
int der_encode_octet_string(int, char*[]);
int der_encode_sequence(int, char*[]);
int der_encode_set(int, char*[]);
int der_decode_negative_int(int, char*[]);
int der_decode_positive_int(int, char*[]);
int der_decode_zero_int(int, char*[]);
int der_decode_bad_length(int, char*[]);
int der_decode_zero_length_int(int, char*[]);
int der_decode_integer(int, char*[]);
int der_decode_integer_zero(int, char*[]);
int der_decode_boolean(int, char*[]);
int der_decode_null(int, char*[]);
int der_decode_bit_string(int, char*[]);
int der_decode_octet_string(int, char*[]);
int der_decode_sequence(int, char*[]);
int der_decode_set(int, char*[]);
int der_decode_key_pair(int, char*[]);
int ecc_key_pair_random_ref_count_test(int, char*[]);
int ecc_key_pair_public_ref_count_test(int, char*[]);
int ecc_key_pair_asn1_ref_count_test(int, char*[]);
int ecc_key_pair_private_ref_count_test(int, char*[]);
int ecc_key_gen_from_private_fuzz_test(int, char*[]);


#ifdef __cplusplus
#  define CM_CAST(TYPE, EXPR) static_cast<TYPE>(EXPR)
#  if __cplusplus >= 201103L
#    define CM_NULL nullptr
#  else
#    define CM_NULL NULL
#  endif
#else
#  define CM_CAST(TYPE, EXPR) (TYPE)(EXPR)
#  define CM_NULL NULL
#endif

/* Create map.  */

typedef int (*MainFuncPointer)(int, char* []); /* NOLINT */
typedef struct /* NOLINT */
{
  const char* name;
  MainFuncPointer func;
} functionMapEntry;

static functionMapEntry cmakeGeneratedFunctionMapEntries[] = {
    {
    "sha256_nist_test_case_1",
    sha256_nist_test_case_1
  },
  {
    "sha256_nist_test_case_2",
    sha256_nist_test_case_2
  },
  {
    "sha256_nist_test_case_3",
    sha256_nist_test_case_3
  },
  {
    "sha256_nist_test_case_4",
    sha256_nist_test_case_4
  },
  {
    "sha256_nist_test_case_5",
    sha256_nist_test_case_5
  },
  {
    "sha256_nist_test_case_5_truncated",
    sha256_nist_test_case_5_truncated
  },
  {
    "sha256_nist_test_case_6",
    sha256_nist_test_case_6
  },
  {
    "sha256_test_invalid_buffer",
    sha256_test_invalid_buffer
  },
  {
    "sha256_test_oneshot",
    sha256_test_oneshot
  },
  {
    "sha256_test_invalid_state",
    sha256_test_invalid_state
  },
  {
    "sha256_test_extra_buffer_space",
    sha256_test_extra_buffer_space
  },
  {
    "sha1_nist_test_case_1",
    sha1_nist_test_case_1
  },
  {
    "sha1_nist_test_case_2",
    sha1_nist_test_case_2
  },
  {
    "sha1_nist_test_case_3",
    sha1_nist_test_case_3
  },
  {
    "sha1_nist_test_case_4",
    sha1_nist_test_case_4
  },
  {
    "sha1_nist_test_case_5",
    sha1_nist_test_case_5
  },
  {
    "sha1_nist_test_case_5_truncated",
    sha1_nist_test_case_5_truncated
  },
  {
    "sha1_nist_test_case_6",
    sha1_nist_test_case_6
  },
  {
    "sha1_test_invalid_buffer",
    sha1_test_invalid_buffer
  },
  {
    "sha1_test_oneshot",
    sha1_test_oneshot
  },
  {
    "sha1_test_invalid_state",
    sha1_test_invalid_state
  },
  {
    "sha1_test_extra_buffer_space",
    sha1_test_extra_buffer_space
  },
  {
    "md5_rfc1321_test_case_1",
    md5_rfc1321_test_case_1
  },
  {
    "md5_rfc1321_test_case_2",
    md5_rfc1321_test_case_2
  },
  {
    "md5_rfc1321_test_case_3",
    md5_rfc1321_test_case_3
  },
  {
    "md5_rfc1321_test_case_4",
    md5_rfc1321_test_case_4
  },
  {
    "md5_rfc1321_test_case_5",
    md5_rfc1321_test_case_5
  },
  {
    "md5_rfc1321_test_case_6",
    md5_rfc1321_test_case_6
  },
  {
    "md5_rfc1321_test_case_7",
    md5_rfc1321_test_case_7
  },
  {
    "md5_rfc1321_test_case_7_truncated",
    md5_rfc1321_test_case_7_truncated
  },
  {
    "md5_verify_known_collision",
    md5_verify_known_collision
  },
  {
    "md5_invalid_buffer_size",
    md5_invalid_buffer_size
  },
  {
    "md5_test_invalid_state",
    md5_test_invalid_state
  },
  {
    "md5_test_extra_buffer_space",
    md5_test_extra_buffer_space
  },
  {
    "sha256_hmac_rfc4231_test_case_1",
    sha256_hmac_rfc4231_test_case_1
  },
  {
    "sha256_hmac_rfc4231_test_case_2",
    sha256_hmac_rfc4231_test_case_2
  },
  {
    "sha256_hmac_rfc4231_test_case_3",
    sha256_hmac_rfc4231_test_case_3
  },
  {
    "sha256_hmac_rfc4231_test_case_4",
    sha256_hmac_rfc4231_test_case_4
  },
  {
    "sha256_hmac_rfc4231_test_case_5",
    sha256_hmac_rfc4231_test_case_5
  },
  {
    "sha256_hmac_rfc4231_test_case_6",
    sha256_hmac_rfc4231_test_case_6
  },
  {
    "sha256_hmac_rfc4231_test_case_7",
    sha256_hmac_rfc4231_test_case_7
  },
  {
    "sha256_hmac_test_oneshot",
    sha256_hmac_test_oneshot
  },
  {
    "sha256_hmac_test_invalid_buffer",
    sha256_hmac_test_invalid_buffer
  },
  {
    "sha256_hmac_test_invalid_state",
    sha256_hmac_test_invalid_state
  },
  {
    "sha256_hmac_test_extra_buffer_space",
    sha256_hmac_test_extra_buffer_space
  },
  {
    "ecdsa_p256_test_pub_key_derivation",
    ecdsa_p256_test_pub_key_derivation
  },
  {
    "ecdsa_p384_test_pub_key_derivation",
    ecdsa_p384_test_pub_key_derivation
  },
  {
    "ecdsa_p256_test_known_signing_value",
    ecdsa_p256_test_known_signing_value
  },
  {
    "ecdsa_p384_test_known_signing_value",
    ecdsa_p384_test_known_signing_value
  },
  {
    "ecdsa_test_invalid_signature",
    ecdsa_test_invalid_signature
  },
  {
    "ecdsa_p256_test_key_gen",
    ecdsa_p256_test_key_gen
  },
  {
    "ecdsa_p384_test_key_gen",
    ecdsa_p384_test_key_gen
  },
  {
    "ecdsa_p256_test_key_gen_export",
    ecdsa_p256_test_key_gen_export
  },
  {
    "ecdsa_p384_test_key_gen_export",
    ecdsa_p384_test_key_gen_export
  },
  {
    "ecdsa_p256_test_import_asn1_key_pair",
    ecdsa_p256_test_import_asn1_key_pair
  },
  {
    "ecdsa_p384_test_import_asn1_key_pair",
    ecdsa_p384_test_import_asn1_key_pair
  },
  {
    "ecdsa_test_import_asn1_key_pair_public_only",
    ecdsa_test_import_asn1_key_pair_public_only
  },
  {
    "ecdsa_test_import_asn1_key_pair_invalid_fails",
    ecdsa_test_import_asn1_key_pair_invalid_fails
  },
  {
    "ecdsa_test_signature_format",
    ecdsa_test_signature_format
  },
  {
    "ecdsa_p256_test_small_coordinate_verification",
    ecdsa_p256_test_small_coordinate_verification
  },
  {
    "rsa_encryption_roundtrip_pkcs1_from_user",
    rsa_encryption_roundtrip_pkcs1_from_user
  },
  {
    "rsa_encryption_roundtrip_oaep_sha256_from_user",
    rsa_encryption_roundtrip_oaep_sha256_from_user
  },
  {
    "rsa_encryption_roundtrip_oaep_sha512_from_user",
    rsa_encryption_roundtrip_oaep_sha512_from_user
  },
  {
    "rsa_signing_roundtrip_pkcs1_sha256_from_user",
    rsa_signing_roundtrip_pkcs1_sha256_from_user
  },
  {
    "rsa_signing_roundtrip_pss_sha256_from_user",
    rsa_signing_roundtrip_pss_sha256_from_user
  },
  {
    "rsa_getters",
    rsa_getters
  },
  {
    "rsa_private_pkcs1_der_parsing",
    rsa_private_pkcs1_der_parsing
  },
  {
    "rsa_public_pkcs1_der_parsing",
    rsa_public_pkcs1_der_parsing
  },
  {
    "rsa_verify_signing_pkcs1_sha256",
    rsa_verify_signing_pkcs1_sha256
  },
  {
    "rsa_verify_signing_pss_sha256",
    rsa_verify_signing_pss_sha256
  },
  {
    "rsa_decrypt_pkcs1",
    rsa_decrypt_pkcs1
  },
  {
    "rsa_decrypt_oaep256",
    rsa_decrypt_oaep256
  },
  {
    "rsa_decrypt_oaep512",
    rsa_decrypt_oaep512
  },
  {
    "rsa_signing_mismatch_pkcs1_sha256",
    rsa_signing_mismatch_pkcs1_sha256
  },
  {
    "aes_cbc_NIST_CBCGFSbox256_case_1",
    aes_cbc_NIST_CBCGFSbox256_case_1
  },
  {
    "aes_cbc_NIST_CBCVarKey256_case_254",
    aes_cbc_NIST_CBCVarKey256_case_254
  },
  {
    "aes_cbc_NIST_CBCVarTxt256_case_110",
    aes_cbc_NIST_CBCVarTxt256_case_110
  },
  {
    "aes_cbc_NIST_CBCMMT256_case_4",
    aes_cbc_NIST_CBCMMT256_case_4
  },
  {
    "aes_cbc_NIST_CBCMMT256_case_9",
    aes_cbc_NIST_CBCMMT256_case_9
  },
  {
    "aes_cbc_test_with_generated_key_iv",
    aes_cbc_test_with_generated_key_iv
  },
  {
    "aes_cbc_validate_materials_fails",
    aes_cbc_validate_materials_fails
  },
  {
    "aes_ctr_RFC3686_Case_7",
    aes_ctr_RFC3686_Case_7
  },
  {
    "aes_ctr_RFC3686_Case_8",
    aes_ctr_RFC3686_Case_8
  },
  {
    "aes_ctr_RFC3686_Case_9",
    aes_ctr_RFC3686_Case_9
  },
  {
    "aes_ctr_test_with_generated_key_iv",
    aes_ctr_test_with_generated_key_iv
  },
  {
    "aes_ctr_validate_materials_fails",
    aes_ctr_validate_materials_fails
  },
  {
    "gcm_NIST_gcmEncryptExtIV256_PTLen_128_Test_0",
    gcm_NIST_gcmEncryptExtIV256_PTLen_128_Test_0
  },
  {
    "gcm_NIST_gcmEncryptExtIV256_PTLen_104_Test_3",
    gcm_NIST_gcmEncryptExtIV256_PTLen_104_Test_3
  },
  {
    "gcm_NIST_gcmEncryptExtIV256_PTLen_256_Test_6",
    gcm_NIST_gcmEncryptExtIV256_PTLen_256_Test_6
  },
  {
    "gcm_NIST_gcmEncryptExtIV256_PTLen_408_Test_8",
    gcm_NIST_gcmEncryptExtIV256_PTLen_408_Test_8
  },
  {
    "gcm_256_KAT_1",
    gcm_256_KAT_1
  },
  {
    "gcm_256_KAT_2",
    gcm_256_KAT_2
  },
  {
    "gcm_256_KAT_3",
    gcm_256_KAT_3
  },
  {
    "gcm_test_with_generated_key_iv",
    gcm_test_with_generated_key_iv
  },
  {
    "aes_gcm_validate_materials_fails",
    aes_gcm_validate_materials_fails
  },
  {
    "aes_keywrap_RFC3394_256BitKey256CekTestVector",
    aes_keywrap_RFC3394_256BitKey256CekTestVector
  },
  {
    "aes_keywrap_Rfc3394_256BitKey_TestIntegrityCheckFailed",
    aes_keywrap_Rfc3394_256BitKey_TestIntegrityCheckFailed
  },
  {
    "aes_keywrap_RFC3394_256BitKeyTestBadPayload",
    aes_keywrap_RFC3394_256BitKeyTestBadPayload
  },
  {
    "aes_keywrap_RFC3394_256BitKey128BitCekTestVector",
    aes_keywrap_RFC3394_256BitKey128BitCekTestVector
  },
  {
    "aes_keywrap_RFC3394_256BitKey128BitCekIntegrityCheckFailedTestVector",
    aes_keywrap_RFC3394_256BitKey128BitCekIntegrityCheckFailedTestVector
  },
  {
    "aes_keywrap_RFC3394_256BitKey128BitCekPayloadCheckFailedTestVector",
    aes_keywrap_RFC3394_256BitKey128BitCekPayloadCheckFailedTestVector
  },
  {
    "aes_keywrap_validate_materials_fails",
    aes_keywrap_validate_materials_fails
  },
  {
    "aes_test_input_too_large",
    aes_test_input_too_large
  },
  {
    "der_encode_integer",
    der_encode_integer
  },
  {
    "der_encode_integer_zero",
    der_encode_integer_zero
  },
  {
    "der_encode_boolean",
    der_encode_boolean
  },
  {
    "der_encode_null",
    der_encode_null
  },
  {
    "der_encode_bit_string",
    der_encode_bit_string
  },
  {
    "der_encode_octet_string",
    der_encode_octet_string
  },
  {
    "der_encode_sequence",
    der_encode_sequence
  },
  {
    "der_encode_set",
    der_encode_set
  },
  {
    "der_decode_negative_int",
    der_decode_negative_int
  },
  {
    "der_decode_positive_int",
    der_decode_positive_int
  },
  {
    "der_decode_zero_int",
    der_decode_zero_int
  },
  {
    "der_decode_bad_length",
    der_decode_bad_length
  },
  {
    "der_decode_zero_length_int",
    der_decode_zero_length_int
  },
  {
    "der_decode_integer",
    der_decode_integer
  },
  {
    "der_decode_integer_zero",
    der_decode_integer_zero
  },
  {
    "der_decode_boolean",
    der_decode_boolean
  },
  {
    "der_decode_null",
    der_decode_null
  },
  {
    "der_decode_bit_string",
    der_decode_bit_string
  },
  {
    "der_decode_octet_string",
    der_decode_octet_string
  },
  {
    "der_decode_sequence",
    der_decode_sequence
  },
  {
    "der_decode_set",
    der_decode_set
  },
  {
    "der_decode_key_pair",
    der_decode_key_pair
  },
  {
    "ecc_key_pair_random_ref_count_test",
    ecc_key_pair_random_ref_count_test
  },
  {
    "ecc_key_pair_public_ref_count_test",
    ecc_key_pair_public_ref_count_test
  },
  {
    "ecc_key_pair_asn1_ref_count_test",
    ecc_key_pair_asn1_ref_count_test
  },
  {
    "ecc_key_pair_private_ref_count_test",
    ecc_key_pair_private_ref_count_test
  },
  {
    "ecc_key_gen_from_private_fuzz_test",
    ecc_key_gen_from_private_fuzz_test
  },

  { CM_NULL, CM_NULL } /* NOLINT */
};

static const int NumTests = CM_CAST(int,
  sizeof(cmakeGeneratedFunctionMapEntries) / sizeof(functionMapEntry)) - 1;

/* Allocate and create a lowercased copy of string
   (note that it has to be free'd manually) */
static char* lowercase(const char* string)
{
  char *new_string;
  char *p;
  size_t stringSize;

  stringSize = CM_CAST(size_t, strlen(string) + 1);
  new_string = CM_CAST(char*, malloc(sizeof(char) * stringSize));

  if (new_string == CM_NULL) { /* NOLINT */
    return CM_NULL;            /* NOLINT */
  }
  strcpy(new_string, string);  /* NOLINT */
  for (p = new_string; *p != 0; ++p) {
    *p = CM_CAST(char, tolower(*p));
  }
  return new_string;
}

int isTestSkipped(const char *name, int n_skipped_tests, char *skipped_tests[]) {
  int i;
  for (i = 0; i < n_skipped_tests; i++) {
    if (strcmp(name, skipped_tests[i]) == 0) {
      return 1;
    }
  }

  return 0;
}

int main(int ac, char* av[])
{
  int i;
  int testNum = 0;
  int partial_match;
  int run_all;
  char *arg;
  int testToRun = -1;

  

  /* If no test name was given */
  /* process command line with user function.  */
  if (ac < 2) {
    /* Ask for a test.  */
    printf("Available tests:\n");
    for (i = 0; i < NumTests; ++i) {
      printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
    }
    printf("To run a test, enter the test number: ");
    fflush(stdout);
    if (scanf("%d", &testNum) != 1) {
      printf("Couldn't parse that input as a number\n");
      return -1;
    }
    if (testNum >= NumTests) {
      printf("%3d is an invalid test number.\n", testNum);
      return -1;
    }
    testToRun = testNum;
    ac--;
    av++;
  }
  partial_match = 0;
  run_all = 0;
  arg = CM_NULL; /* NOLINT */
  /* If partial match or running all tests are requested.  */
  if (testToRun == -1 && ac > 1) {
    partial_match = (strcmp(av[1], "-R") == 0) ? 1 : 0;
    run_all = (strcmp(av[1], "-A") == 0) ? 1 : 0;
  }
  if (partial_match != 0 && ac < 3) {
    printf("-R needs an additional parameter.\n");
    return -1;
  }
  if (run_all == 1) {
    clock_t t;
    int status = 0;
    const char* status_message = CM_NULL;
    printf("TAP version 13\n");
    printf("1..%d\n", NumTests);
    for (i = 0; i < NumTests; ++i) {
      const char *name = cmakeGeneratedFunctionMapEntries[i].name;
      if (ac > 2) {
        if (isTestSkipped(name, ac - 2, av + 2) == 1) {
          printf("ok %d %s # SKIP\n", i + 1, name);
          continue;
        }
      }
      t = clock();
      status = (*cmakeGeneratedFunctionMapEntries[i].func)(ac, av);
      t = clock() - t;
      status_message = (status == -1) ? "not ok" : "ok";
      {
        double time_taken = CM_CAST(double, t) / CLOCKS_PER_SEC;
        printf("%s %d %s # %f\n", status_message, i + 1, name, time_taken);
      }
    }
    printf("All tests finished.\n");

    return 0;
  }

  if (testToRun == -1) {
    arg = lowercase(av[1 + partial_match]);
  }
  for (i = 0; i < NumTests && testToRun == -1; ++i) {
    char *test_name = lowercase(cmakeGeneratedFunctionMapEntries[i].name);
    if (partial_match != 0 && strstr(test_name, arg) != CM_NULL) { /* NOLINT */
      testToRun = i;
      ac -= 2;
      av += 2;
    } else if (partial_match == 0 && strcmp(test_name, arg) == 0) {
      testToRun = i;
      ac--;
      av++;
    }
    free(test_name);
  }
  free(arg);
  if (testToRun != -1) {
    int result;

    if (testToRun < 0 || testToRun >= NumTests) {
      printf("testToRun was modified by TestDriver code to an invalid value: "
             "%3d.\n",
             testNum);
      return -1;
    }
    result = (*cmakeGeneratedFunctionMapEntries[testToRun].func)(ac, av);

    return result;
  }

  /* Nothing was run, display the test names.  */
  printf("Available tests:\n");
  for (i = 0; i < NumTests; ++i) {
    printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
  }
  printf("Failed: %s is an invalid test name.\n", av[1]);

  return -1;
}
